'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _LayoutState = require('./model/LayoutState');

var _LayoutState2 = _interopRequireDefault(_LayoutState);

var _utils = require('./utils');

var _wrapper = require('./wrapper');

var _wrapper2 = _interopRequireDefault(_wrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RootLayout = function RootLayout(_ref) {
  var layoutState = _ref.layoutState;
  var components = _ref.components;
  var readOnly = _ref.readOnly;

  var rootItem = layoutState.getItemJS('root');
  var RootComp = components[rootItem.type];
  return _react2.default.createElement(
    'div',
    { style: _extends({}, rootItem.style, { position: 'relative', minHeight: 40 }), onClick: readOnly ? null : function () {
        return layoutState.setSelectedItem('root');
      } },
    _react2.default.createElement(
      RootComp,
      _extends({}, rootItem.props, { id: 'root' }),
      _react2.default.Children.map(rootItem.children, function (childId) {
        return (0, _wrapper2.default)(readOnly, childId);
      })
    )
  );
};

RootLayout.propTypes = {
  layoutState: _react.PropTypes.instanceOf(_LayoutState2.default).isRequired,
  components: _react.PropTypes.object.isRequired,
  readOnly: _react.PropTypes.bool
};

exports.default = (0, _utils.connect)('layoutState', 'components', 'readOnly')(RootLayout);