'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDnd = require('react-dnd');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var source = {
  beginDrag: function beginDrag(props, monitor) {
    return { type: props.type, props: {}, children: [], style: {} };
  },
  endDrag: function endDrag(props, monitor) {
    if (monitor.didDrop()) {
      var item = {
        id: (0, _utils.generateRandomKey)(),
        props: {},
        children: []
      };
      var dropResult = monitor.getDropResult();
    }
  }
};

var CatalogItem = function CatalogItem(_ref) {
  var type = _ref.type;
  var component = _ref.component;
  var connectDragSource = _ref.connectDragSource;
  return connectDragSource(_react2.default.createElement(
    'div',
    { style: { backgroundColor: '#444', color: '#eee', padding: 10 } },
    type
  ));
};

exports.default = (0, _reactDnd.DragSource)('Component', source, function (connect, monitor) {
  return {
    connectDragSource: connect.dragSource()
  };
})(CatalogItem);