'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _CatalogItem = require('./CatalogItem');

var _CatalogItem2 = _interopRequireDefault(_CatalogItem);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Catalog = function Catalog(_ref) {
  var components = _ref.components;
  return _react2.default.createElement(
    'div',
    { style: styles.container },
    Object.keys(components).map(function (key) {
      return _react2.default.createElement(_CatalogItem2.default, { key: key, type: key, component: components[key] });
    })
  );
};

var styles = {
  container: {
    backgroundColor: '#455A64',
    width: 200,
    height: '100%'
  }
};

Catalog.propTypes = {
  components: _react.PropTypes.object.isRequired
};

exports.default = (0, _utils.connect)('components')(Catalog);