'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDnd = require('react-dnd');

var _Separator = require('./Separator');

var _Separator2 = _interopRequireDefault(_Separator);

var _utils = require('../../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var target = {
  drop: function drop(props, monitor, component) {
    if (!monitor.didDrop()) {
      props.layoutState.addItem(props.id, props.children.length, monitor.getItem());
    }
  }
};

var EditLayout = function EditLayout(_ref) {
  var id = _ref.id;
  var children = _ref.children;
  var isOverCurrent = _ref.isOverCurrent;
  var connectDropTarget = _ref.connectDropTarget;
  var type = _ref.type;
  var layoutState = _ref.layoutState;
  var readOnly = _ref.readOnly;


  var parsedChildren = [];
  if (!readOnly && children.length) {
    var _loop = function _loop(i) {
      if (i % 2 === 0) {
        parsedChildren.push(_react2.default.createElement(_Separator2.default, {
          key: id + '-seperator-' + i,
          onDrop: function onDrop(item) {
            return layoutState.addItem(id, i / 2, item);
          },
          direction: type === 'row' ? 'vertical' : 'horizontal'
        }));
      } else {
        parsedChildren.push(children[(i - 1) / 2]);
      }
    };

    for (var i = 0; i < children.length * 2 + 1; i++) {
      _loop(i);
    }
  } else {
    parsedChildren = children;
  }

  return connectDropTarget(_react2.default.createElement(
    'div',
    { style: {
        boxSizing: 'border-box',
        height: '100%',
        minHeight: children.length ? null : 30,
        minWidth: children.length ? null : 30,
        padding: 10,
        display: type === 'row' ? 'flex' : null
      } },
    _react2.default.createElement('div', { style: {
        position: 'absolute',
        pointerEvents: 'none',
        top: 0,
        left: 0,
        width: '100%',
        height: '100%',
        backgroundColor: isOverCurrent ? 'rgba(25, 230, 240, 0.2)' : ''
      } }),
    parsedChildren
  ));
};

var LayoutContainer = (0, _reactDnd.DropTarget)('Component', target, function (conn, monitor) {
  return {
    connectDropTarget: conn.dropTarget(),
    isOverCurrent: monitor.isOver({ shallow: true })
  };
})(EditLayout);

exports.default = (0, _utils.connect)('layoutState', 'readOnly')(LayoutContainer);

// export default LayoutContainer;s