'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDnd = require('react-dnd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var target = {
  drop: function drop(props, monitor) {
    if (!monitor.didDrop()) {
      props.onDrop(monitor.getItem());
    }
  }
};

var Separator = function Separator(_ref) {
  var direction = _ref.direction;
  var connectDropTarget = _ref.connectDropTarget;
  var isOverCurrent = _ref.isOverCurrent;
  var canDrop = _ref.canDrop;
  return _react2.default.createElement(
    'div',
    { style: {
        position: 'relative',
        zIndex: 10,
        backgroundColor: '#b535e5'
      } },
    connectDropTarget(_react2.default.createElement(
      'div',
      { style: {
          display: canDrop ? 'flex' : 'none',
          position: 'absolute',
          alignItems: 'center',
          justifyContent: 'center',
          width: direction === 'vertical' ? 20 : '100%',
          height: direction === 'vertical' ? '100%' : 20,
          top: direction === 'vertical' ? 0 : -10,
          left: direction === 'vertical' ? -10 : 0
        } },
      isOverCurrent ? _react2.default.createElement('div', { style: {
          width: direction === 'vertical' ? 4 : '100%',
          height: direction === 'vertical' ? '100%' : 4,
          borderRadius: 2,
          backgroundColor: 'rgba(25, 230, 240, 1)'
        } }) : null
    ))
  );
};

exports.default = (0, _reactDnd.DropTarget)('Component', target, function (connect, monitor) {
  return {
    isOverCurrent: monitor.isOver({ shallow: true }),
    connectDropTarget: connect.dropTarget(),
    canDrop: monitor.canDrop()
  };
})(Separator);