'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Breadcrumb = function Breadcrumb(_ref) {
  var layoutState = _ref.layoutState;

  var ancestors = layoutState.getAncestors(layoutState.selectedItem);
  return _react2.default.createElement(
    'div',
    null,
    ancestors.map(function (item, idx) {
      return _react2.default.createElement(
        'span',
        { key: item.id },
        _react2.default.createElement(
          'span',
          {
            style: style(idx === ancestors.length - 1),
            onClick: function onClick() {
              return layoutState.setSelectedItem(item.id);
            }
          },
          item.type
        ),
        idx === ancestors.length - 1 ? '' : _react2.default.createElement(
          'span',
          { style: { fontWeight: 'bold', cursor: 'default' } },
          '>'
        )
      );
    })
  );
};

var style = function style(current) {
  return {
    padding: '0 5px',
    cursor: 'pointer',
    fontWeight: current ? 'bold' : 'normal'
  };
};

exports.default = (0, _utils.connect)('layoutState')(Breadcrumb);