'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Tag = function Tag(_ref) {
  var layoutState = _ref.layoutState;
  var id = _ref.id;

  var item = layoutState.getItemJS(id);
  var current = id === layoutState.selectedItem;
  var handleClick = function handleClick() {
    return layoutState.setSelectedItem(id);
  };
  return item.children.length ? _react2.default.createElement(
    'div',
    { style: style(current) },
    _react2.default.createElement(
      'div',
      { onClick: handleClick },
      '<',
      item.type,
      '>'
    ),
    item.children.map(function (childId) {
      return _react2.default.createElement(
        'div',
        { key: childId, style: { paddingLeft: 15 } },
        _react2.default.createElement(Renderer, { id: childId })
      );
    }),
    _react2.default.createElement(
      'div',
      { onClick: handleClick },
      '</',
      item.type,
      '>'
    )
  ) : _react2.default.createElement(
    'div',
    { style: style(current), onClick: handleClick },
    '<',
    item.type,
    ' />'
  );
};

var style = function style(curr) {
  return {
    cursor: 'pointer',
    fontWeight: 'bold',
    backgroundColor: curr ? 'rgba(255, 255, 255, 0.3)' : ''
  };
};

var Renderer = (0, _utils.connect)('layoutState')(Tag);

exports.default = Renderer;