'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _LayoutState = require('../model/LayoutState');

var _LayoutState2 = _interopRequireDefault(_LayoutState);

var _utils = require('../utils');

var _Breadcrumb = require('./Breadcrumb');

var _Breadcrumb2 = _interopRequireDefault(_Breadcrumb);

var _JSXRenderer = require('./JSXRenderer');

var _JSXRenderer2 = _interopRequireDefault(_JSXRenderer);

var _parseCss = require('../utils/parseCss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ItemEditor = function (_Component) {
  _inherits(ItemEditor, _Component);

  function ItemEditor(props) {
    _classCallCheck(this, ItemEditor);

    var _this = _possibleConstructorReturn(this, (ItemEditor.__proto__ || Object.getPrototypeOf(ItemEditor)).call(this, props));

    _this.updateStyle = function (e) {
      _this.setState({ style: e.target.value });
    };

    _this.saveStyle = function (e) {
      try {
        (function () {
          var nextStyle = (0, _parseCss.cssToJS)(_this.state.style);
          _this.props.layoutState.updateItem(_this.props.layoutState.selectedItem)(['style'], function () {
            return nextStyle;
          });
        })();
      } catch (err) {
        console.log(err.message);
      }
    };

    var item = props.layoutState.getSelectedItem();
    if (item) {
      _this.state = {
        style: (0, _parseCss.jsToCss)(item.style, null, 2)
      };
    }
    return _this;
  }

  _createClass(ItemEditor, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.layoutState.selectedItem && nextProps.layoutState.selectedItem !== this.props.layoutState.selectedItem) {
        this.setState({ style: (0, _parseCss.jsToCss)(nextProps.layoutState.getSelectedItem().style) });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var layoutState = _props.layoutState;
      var addons = _props.addons;


      var selectedItem = layoutState.getSelectedItem();

      if (!selectedItem) return null;

      return _react2.default.createElement(
        'div',
        { style: styles.container },
        _react2.default.createElement(
          'button',
          { onClick: function onClick() {
              return layoutState.setSelectedItem(null);
            } },
          'x'
        ),
        addons.map(function (addon) {
          return _react2.default.createElement(
            'div',
            { key: addon.Label },
            addon.Label
          );
        }),
        _react2.default.createElement(_Breadcrumb2.default, null),
        _react2.default.createElement(
          'button',
          { onClick: function onClick() {
              return layoutState.removeItem(layoutState.selectedItem);
            } },
          'Delete'
        ),
        _react2.default.createElement(
          'h4',
          null,
          'Styling'
        ),
        _react2.default.createElement('textarea', {
          placeholder: 'Enter css styles here',
          value: this.state.style,
          onChange: this.updateStyle,
          style: { width: '100%', boxSizing: 'border-box', height: 200 }
        }),
        _react2.default.createElement(
          'button',
          { onClick: this.saveStyle },
          'Save'
        ),
        _react2.default.createElement('hr', null),
        _react2.default.createElement(_JSXRenderer2.default, { id: 'root' })
      );
    }
  }]);

  return ItemEditor;
}(_react.Component);

var styles = {
  container: {
    backgroundColor: '#455A64',
    width: 300,
    height: '100%',
    boxSizing: 'border-box',
    padding: 10
  }
};

ItemEditor.propTypes = {
  addons: _react.PropTypes.array
};

exports.default = (0, _utils.connect)('layoutState', 'addons')(ItemEditor);