'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cssToJS = cssToJS;
exports.jsToCss = jsToCss;
function cssToJS(str) {
  var lines = str.split(';').filter(function (line) {
    return line.trim();
  });
  var result = {};
  lines.forEach(function (line) {
    var pair = line.split(':');
    var key = dashToCamel(pair[0].trim());
    result[key] = pair[1].trim();
  });
  return result;
}

function jsToCss(json) {
  var result = '';
  Object.keys(json).forEach(function (key) {
    result += camelToDash(key) + ': ';
    result += json[key] + ';\n';
  });
  return result;
}

function dashToCamel(str) {
  return str.split('-').map(function (word, idx) {
    if (idx === 0) return word;
    return word[0].toUpperCase() + word.slice(1);
  }).join('');
}

function camelToDash(str) {
  var result = '';
  for (var i = 0; i < str.length; i++) {
    var letter = str[i];
    if (letter.toUpperCase() === letter) {
      result += '-' + letter.toLowerCase();
    } else {
      result += letter;
    }
  }
  return result;
}