"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Store = function () {
  function Store(state) {
    _classCallCheck(this, Store);

    this.state = state;
    this.listeners = {};
  }

  _createClass(Store, [{
    key: "update",
    value: function update(key, value) {
      this.state[key] = value;
      this.listeners[key].forEach(function (listener) {
        listener(key, value);
      });
    }
  }, {
    key: "subscribe",
    value: function subscribe(keys, listener) {
      var _this = this;

      var result = {};
      keys.forEach(function (key) {
        if (_this.listeners[key]) {
          _this.listeners[key].add(listener);
        } else {
          _this.listeners[key] = new Set([listener]);
        }
        result[key] = _this.state[key];
      });
      return result;
    }
  }, {
    key: "unsubscribe",
    value: function unsubscribe(keys, listener) {
      var _this2 = this;

      keys.forEach(function (key) {
        if (_this2.listeners[key]) {
          _this2.listeners[key].delete(listener);
        }
      });
    }
  }]);

  return Store;
}();

exports.default = Store;