'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDnd = require('react-dnd');

var _LayoutState = require('../model/LayoutState');

var _LayoutState2 = _interopRequireDefault(_LayoutState);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var source = {
  beginDrag: function beginDrag(props, monitor) {
    return props.layoutState.getItemJS(props.id);
  }
};

var EditWrapper = function (_Component) {
  _inherits(EditWrapper, _Component);

  function EditWrapper(props) {
    _classCallCheck(this, EditWrapper);

    var _this = _possibleConstructorReturn(this, (EditWrapper.__proto__ || Object.getPrototypeOf(EditWrapper)).call(this, props));

    _this.setHover = function (bool) {
      return function (e) {
        _this.setState({ hovered: bool });
      };
    };

    _this.handleClick = function (e) {
      e.stopPropagation();
      _this.props.layoutState.setSelectedItem(_this.props.id);
    };

    _this.state = {
      hovered: false
    };
    return _this;
  }

  _createClass(EditWrapper, [{
    key: 'render',
    value: function render() {
      var addons = this.context.addons;
      var _props = this.props;
      var id = _props.id;
      var layoutState = _props.layoutState;
      var connectDragSource = _props.connectDragSource;
      var isDragging = _props.isDragging;
      var components = _props.components;
      var hovered = this.state.hovered;

      var item = layoutState.getItemJS(id);
      var Comp = components[item.type];

      if (isDragging) return null;

      return connectDragSource(_react2.default.createElement(
        'div',
        {
          style: _extends({}, item.style, {
            position: 'relative',
            outline: layoutState.selectedItem === id ? '2px solid rgba(25, 230, 240, 1)' : hovered ? '1px solid rgba(0,0,0,0.3)' : '1px solid rgba(0,0,0,0.1)',
            outlineOffset: layoutState.selectedItem === id ? -2 : -1
          }),
          onMouseEnter: this.setHover(true),
          onMouseLeave: this.setHover(false),
          onClick: this.handleClick
        },
        _react2.default.createElement(
          Comp,
          _extends({}, item.props, { id: item.id }),
          _react2.default.Children.map(item.children, function (child, idx) {
            return _react2.default.createElement(Wrapper, {
              key: child,
              id: child
            });
          })
        )
      ));
    }
  }]);

  return EditWrapper;
}(_react.Component);

EditWrapper.contextTypes = {
  components: _react.PropTypes.object,
  addons: _react.PropTypes.array
};

EditWrapper.propTypes = {
  id: _react.PropTypes.string.isRequired,
  layoutState: _react.PropTypes.instanceOf(_LayoutState2.default).isRequired
};

var Wrapper = (0, _utils.connect)('layoutState', 'components')((0, _reactDnd.DragSource)('Component', source, function (conn, monitor) {
  return {
    connectDragSource: conn.dragSource(),
    isDragging: monitor.isDragging()
  };
})(EditWrapper));

exports.default = Wrapper;