'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _LayoutState = require('../model/LayoutState');

var _LayoutState2 = _interopRequireDefault(_LayoutState);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StaticWrapper = function StaticWrapper(_ref) {
  var id = _ref.id;
  var components = _ref.components;
  var layoutState = _ref.layoutState;

  var item = layoutState.getItem(id).toJS();
  var Comp = components[item.type];
  return _react2.default.createElement(
    'div',
    { style: _extends({}, item.style, { position: 'relative' }) },
    _react2.default.createElement(
      Comp,
      _extends({}, item.props, { id: id }),
      _react2.default.Children.map(item.children, function (child) {
        return _react2.default.createElement(Wrapper, { key: child, id: child });
      })
    )
  );
};

var styles = function styles() {
  return {
    container: {
      position: 'relative'
    }
  };
};

StaticWrapper.propTypes = {
  id: _react.PropTypes.string.isRequired,
  layoutState: _react.PropTypes.instanceOf(_LayoutState2.default).isRequired,
  components: _react.PropTypes.object.isRequired
};

var Wrapper = (0, _utils.connect)('layoutState', 'components')(StaticWrapper);

exports.default = Wrapper;